close all
clear all
clc

% Pretpostavljamo da su varijable funkcije 
% f(x1,x2,x3) = (x1*x2*sin(x3) + exp(x1*x2))/x3
% komponente vektora x = [x1;x2;x3]

x = [1.0;1.5;0.5]; % tocke u kojima zelimo izracunati vrijednosti derivacija funkcije
n = length(x); % iako znamo da je n=3 ovdje upoznajemo funkciju length()

x1 = x; % inicijalizacija algoritma

%%%% ALGORITAM
for k = 1:50
    h = 10^(-k); % korak diferenciranja kojeg mijenjamo kroz petlju 10^-1, 10^-2, ... 10^-50
    
    % Analiticko rjesenje za usporedbu numerike: egzaktne vrijednosti komponenata vektora gradijenta
    Ja_x(1) = (x(2)*exp(x(1)*x(2)) + x(2)*sin(x(3)))/x(3); 
    Ja_x(2) = (x(1)*exp(x(1)*x(2)) + x(1)*sin(x(3)))/x(3); 
    Ja_x(3) = (x(1)*x(2)*cos(x(3)))/x(3) - (exp(x(1)*x(2)) + x(1)*x(2)*sin(x(3)))/x(3)^2;
    
    % Od ovih komentara pa do dijela koda koji racuna relativnu pogresku
    % napisati algoritam (opisan u prilozenom pdf-u) za racunanje gradijenta 
    % primjenom kompleksne koracne metode. Algoritam realizirati pomocu for-end petlje.
    % Varijabli imena Jc_x (jer se kasnije koristi s tim imenom) pridruzite izracunati vektor gradijent.
    for j = 1:n
        x1(j) = complex(x(j), h);
        f1 = (x1(1)*x1(2)*sin(x1(3)) + exp(x1(1)*x1(2)))/x1(3);
        Jc_x(j) = imag(f1)/h;
        x1 = x;
    end   
    
    % Relativna pogreska: k-tom elementu vektora err u svakoj iteraciji petlje for k=1:50 
    % cemo pridruziti novu vrijednost pogreske.
    Kk(k) = k; % vektor Kk nam treba za kasniji graficki prikaz
    err(k) = (norm(Jc_x - Ja_x)/norm(Ja_x));
end
%%%%

% Graficki prikaz relativne pogreske kao funkcije koraka difrenciranja
semilogy(Kk, err+eps/2) % funkcija semilogy stvara koordinatni sustav s log. mjerilom na y-osi.
xlabel('k (korak diferenciranja h=10^{-k})')
ylabel('Relativna pogreska u log. mjerilu')